package com.hungraim.ltc.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ltc.pojo.entity.SysConfig.ChFndAttach;
import com.hungraim.ltc.pojo.entity.assessment.ChAprReport;
import com.hungraim.ltc.pojo.entity.assessment.ChAprTask;
import com.hungraim.ltc.pojo.entity.assessment.ChRefuseReason;
import com.hungraim.ltc.pojo.entity.assessment.ChTaskReportFractionDtl;
import com.hungraim.ltc.pojo.entity.disable.ChCfgSrvDisableLevel;
import com.hungraim.ltc.pojo.vo.assessment.*;
import com.hungraim.ltc.util.Result;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 失能评定Service
 *
 * @author czz
 */
@Service
public interface TaskService {

    Page<TaskDistributionVO> taskDistributionList(Page<TaskDistributionVO> page, String organId, String provincial, String city,
                                                  String street, String realName, String certiCode, String taskName, String taskTel,
                                                  String daysRemaining, String taskStatus, String isReturn, String area);

    List<TaskReportVO> taskReportList(String name, String certiCode, String tel);

    List<AprEmpVO> aprEmpList(String provincial, String city, String area, String organName, String name, String tel, String groupLeader);

    Result<Object> addReport(Integer taskId, Integer person1, Integer person2, Integer person3, Date evaluateTime, Integer disableLevelId, String polNo, String remark, List<ChFndAttach> fileDataList);

    void updateReport(Integer reportId, Integer person1, Integer person2, Integer person3, Date evaluateDate, Integer disableLevelId, String polNo, String remark, List<ChFndAttach> fileDataList);

    Result<Object> allotTask(String taskId, String empId);

    List<TaskGroupVO> taskGroupList(String name, String certiCode, String tel);

    Result<Object> taskGroup(Integer pushId, Integer status, Short refuseReason, String refuseRemark);

    List<ChCfgSrvDisableLevel> cfgSrvDisableLevelList();

    List<PersonInfoVO> personInfoList(String reportId);

    List<TaskGroupInfoVO> taskGroupInfoList(String groupNumber);

    Result<Object> taskGroupByGroup(String groupNumber, Integer status, Short refuseReason, String refuseRemark);

    TaskGroupInfoListInfoVO taskGroupInfoListInfo(String pushId);

    List<AllotTaskHisVO> allotTaskHisList(Integer taskId);

    Result<Object> updatePushTimeAndRemark(String pushId, Date timeDate, String remark);

    List<ChRefuseReason> refuseReasonList();

    Result<List<ChFndAttach>> reportFileList(Long reportId);

    Result<Object> taskRefuseCause(String taskId, String optType, String aprOrganId, String aprEmpId, String optTime, String refuseReason, String refuseRemark, String status, String taskGroupNo, String taskPushId) throws TppesApiException;

    Result<Object> deleteVodFile(String fileId, String taskId);

    int uploadVideo(String taskId, String videoUrl, String videoName, String padUserName, String fileId);

    List<Map<String,Object>> findReportVideo(String taskId);

    Result<Object> startApprTask(String  taskId,String operationId,String  operationOrganId,String taskGroupNo) throws TppesApiException;

    List<TaskGroupInfoVO> queryAppraisalInfo(String aprEmpId, String appointStartTime, String appointEndTime, String queryBeginDate, String queryEndDate, String groupNum, Integer pageNo, Integer pageSize);

    Page<TaskGroupInfoByPageVO> queryAppraisalInfoByPage(String aprEmpId, String appointStartTime, String appointEndTime, String queryBeginDate, String queryEndDate, String groupNum, Integer pageNo, Integer pageSize);

    ChAprReport taskReportDetails(String taskId) throws TppesApiException;

    ChAprTask singleTaskDetails(String taskId, String taskGroupNo, String taskPushId) throws TppesApiException;

    ChAprTask singleTaskDetailsWuXi(String taskId, String taskGroupNo, String taskPushId) throws TppesApiException;

    ChAprReport queryAprReportForWUXI(String taskId) throws TppesApiException;

    IPage<ChAprTask> apprTaskDetailInfo(String appointStartTime, String appointEndTime, String status, String taskGroupNo, Integer pageNo, Integer pageSize) throws TppesApiException;

    Map taskReportFractionDtlQueryList();
}
